diff --git a/game/core/src/main/java/net/minecraft/core/world/World.java b/game/core/src/main/java/net/minecraft/core/world/World.java
index 96650f788..5f83f8b14 100644
--- a/game/core/src/main/java/net/minecraft/core/world/World.java
+++ b/game/core/src/main/java/net/minecraft/core/world/World.java
@@ -2,6 +2,7 @@ package net.minecraft.core.world;
 
 import com.mojang.logging.LogUtils;
 import it.unimi.dsi.fastutil.objects.ObjectArrayList;
+import it.unimi.dsi.fastutil.objects.ObjectLinkedOpenHashSet;
 import it.unimi.dsi.fastutil.objects.ObjectOpenHashSet;
 import net.minecraft.core.Global;
 import net.minecraft.core.NextTickListEntry;
@@ -32,6 +33,7 @@ import net.minecraft.core.util.debug.Debug;
 import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.helper.LightIndexHelper;
 import net.minecraft.core.util.helper.MathHelper;
+import net.minecraft.core.util.helper.NeighborUpdates;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.util.phys.HitResult;
 import net.minecraft.core.world.biome.Biome;
@@ -634,6 +636,22 @@ public abstract class World implements MutableWorldSource {
         }
     }
 
+    public boolean setBlockTypeDataEntity(final @NotNull TilePosc tilePos, final @NotNull Block<?> block, final int data, final @NotNull TileEntity entity) {
+        if (!tilePos.inBounds(this)) return false;
+        
+        final var c = this.getChunk(tilePos);
+        final var ctp = new ChunkTilePos(tilePos);
+        final var prevBlock = c.getBlock(ctp);
+        final var prevData = c.getBlockData(ctp);
+        if (!c.setBlockIdDataRaw(ctp, block.id(), data)) return false;
+
+        this.replaceTileEntity(tilePos, entity);
+        prevBlock.getLogic().onRemoved(this, tilePos, prevData);
+        block.getLogic().onPlacedByWorld(this, tilePos);
+
+        return true;
+    }
+
     public boolean setBlockTypeRaw(final @NotNull TilePosc tilePos, final @NotNull Block<?> block) {
         return this.setBlockTypeDataRaw(tilePos, block, this.getBlockData(tilePos));
     }
@@ -656,6 +674,10 @@ public abstract class World implements MutableWorldSource {
         return this.setBlockTypeDataRaw(new TilePos(x, y, z), Objects.requireNonNull(Blocks.getBlock(id)), metadata);
     }
 
+    public boolean setBlockTypeEntity(final @NotNull TilePosc tilePos, final @NotNull Block<?> block, final @NotNull TileEntity entity) {
+        return this.setBlockTypeDataEntity(tilePos, block, this.getBlockData(tilePos), entity);
+    }
+
     @Override
     public boolean setBlockType(final @NotNull TilePosc tilePos, final @NotNull Block<?> block) {
         if (!tilePos.inBounds(this)) {
@@ -708,6 +730,15 @@ public abstract class World implements MutableWorldSource {
         }
     }
 
+    public boolean setBlockTypeEntityNotify(final @NotNull TilePosc tilePos, final @NotNull Block<?> block, final @NotNull TileEntity entity) {
+        if (this.setBlockTypeEntity(tilePos, block, entity)) {
+            this.notifyBlockChange(tilePos, block);
+            return true;
+        }
+
+        return false;
+    }
+
     public boolean setBlockTypeNotify(final @NotNull TilePosc tilePos, final @NotNull Block<?> block) {
         if (this.setBlockType(tilePos, block)) {
             this.notifyBlockChange(tilePos, block);
@@ -722,6 +753,15 @@ public abstract class World implements MutableWorldSource {
         return this.setBlockTypeNotify(new TilePos(x, y, z), Objects.requireNonNull(Blocks.getBlock(id)));
     }
 
+    public boolean setBlockTypeDataEntityNotify(final @NotNull TilePosc tilePos, final @NotNull Block<?> block, final int data, final @NotNull TileEntity entity) {
+        if (this.setBlockTypeDataEntity(tilePos, block, data, entity)) {
+            this.notifyBlockChange(tilePos, block);
+            return true;
+        }
+
+        return false;
+    }
+
     public boolean setBlockTypeDataNotify(final @NotNull TilePosc tilePos, final @NotNull Block<?> block, final int data) {
         if (this.setBlockTypeData(tilePos, block, data)) {
             this.notifyBlockChange(tilePos, block);
@@ -790,27 +830,114 @@ public abstract class World implements MutableWorldSource {
         this.markBlocksDirty(new TilePos(minX, minY, minZ), new TilePos(maxX, maxY, maxZ));
     }
 
-    public void notifyBlocksOfNeighborChange(final @NotNull TilePosc tilePos, final @NotNull Block<?> block) {
-        final TilePos queryPos = new TilePos();
-        this.notifyBlockOfNeighborChange(tilePos.add(Direction.WEST, queryPos), block);
-        this.notifyBlockOfNeighborChange(tilePos.add(Direction.EAST, queryPos), block);
-        this.notifyBlockOfNeighborChange(tilePos.add(Direction.DOWN, queryPos), block);
-        this.notifyBlockOfNeighborChange(tilePos.add(Direction.UP, queryPos), block);
-        this.notifyBlockOfNeighborChange(tilePos.add(Direction.NORTH, queryPos), block);
-        this.notifyBlockOfNeighborChange(tilePos.add(Direction.SOUTH, queryPos), block);
+    /**
+     * Notify blocks adjacent to the given position
+     * of neighbor update originated from the given block,
+     * or the block at the given position if null.
+     */
+    public void notifyBlocksOfNeighborChange(final @NotNull TilePosc tilePos, final @Nullable Block<?> block) {
+        if (this.noNeighborUpdate || this.isClientSide) return;
+        NeighborUpdates.diamondD1(this, tilePos, block);
     }
 
-    @Deprecated
-    public final void notifyBlocksOfNeighborChange(final int x, final int y, final int z, final int id) {
-        this.notifyBlocksOfNeighborChange(new TilePos(x, y, z), Objects.requireNonNull(Blocks.getBlock(id)));
+    /**
+     * Notify blocks in the provided radius -- such that (|dx| + |dy| + |dz| <= radius) --
+     * from the given position of neighbor update originated from the given block,
+     * or the block at the given position if null.
+     */
+    public void notifyBlocksInRadiusOfNeighborChange(
+        final int radius, 
+        final @NotNull TilePosc tilePos, final @Nullable Block<?> block
+    ) {
+        if (this.noNeighborUpdate || this.isClientSide) return;
+        NeighborUpdates.diamondDn(radius, this, tilePos, block);
     }
 
-    private void notifyBlockOfNeighborChange(final @NotNull TilePosc tilePos, final @NotNull Block<?> block) {
-        if (this.noNeighborUpdate || this.isClientSide) {
-            return;
+    /**
+     * Notify blocks with exactly the provided radius -- such that (|dx| + |dy| + |dz| == radius) --
+     * from the given position of neighbor update originated from the given block,
+     * or the block at the given position if null.
+     */
+    public void notifyShellBlocksInRadiusOfNeighborChange(
+        final int radius, final @NotNull TilePosc tilePos, @Nullable Block<?> block
+    ) {
+        if (this.noNeighborUpdate || this.isClientSide) return;
+        NeighborUpdates.diamondDnShell(radius, this, tilePos, block);
+    }
+
+    /**
+     * Notify adjacent blocks from the given position,
+     * and from the adjacent position on the given direction of the position,
+     * of neighbor update originated from the given block,
+     * or the block at the given position if null (avoiding duplicated updates).
+     */
+    public void notifyBlocksInCapsuleOfNeighborChange(
+        @NotNull Direction direction, final @NotNull TilePosc tilePos,
+        final @Nullable Block<?> block
+    ) {
+        if (this.noNeighborUpdate || this.isClientSide) return;
+        NeighborUpdates.diamondD2SingleDir(direction, this, tilePos, block);
+    }
+
+    /**
+     * Notify adjacent blocks from the given position,
+     * and from the position on the given side of the position,
+     * of neighbor update originated from the given block,
+     * or the block at the given position if null (avoiding duplicated updates).
+     */
+    public void notifyBlocksInCapsuleOfNeighborChange(
+        @NotNull Side side, final @NotNull TilePosc tilePos,
+        final @Nullable Block<?> block
+    ) {
+        this.notifyBlocksInCapsuleOfNeighborChange(side.direction(), tilePos, block);
+    }
+
+    /**
+     * Notify blocks adjacent to every provided positions,
+     * of neighbor update originated from the given block,
+     * or the block at *each* positions if null (avoiding duplicated updates).
+     */
+    public synchronized void notifyBlocksOfNeighborChanges(
+        final @NotNull TilePosc @NotNull[] tilePositions, @Nullable Block<?> block
+    ) {
+        class ctx { static final ObjectOpenHashSet<TilePosc> CACHE = new ObjectOpenHashSet<>(); }
+        if (this.noNeighborUpdate || this.isClientSide) return;
+        ctx.CACHE.clear();
+        ctx.CACHE.ensureCapacity(tilePositions.length * (6 / 2));
+
+        for (var pos : tilePositions) {
+            NeighborUpdates.diamondD1(ctx.CACHE, this, pos, block);
         }
 
-        this.getBlockType(tilePos).onNeighborChanged(this, tilePos, block);
+        final var size = ctx.CACHE.size();
+        ctx.CACHE.clear();
+        if (size >= 1024) ctx.CACHE.trim(512);
+    }
+
+    /**
+     * Notify blocks adjacent to every provided positions,
+     * of neighbor update originated from the given block,
+     * or the block at *each* positions if null (avoiding duplicated updates).
+     */
+    public synchronized <T extends TilePosc> void notifyBlocksOfNeighborChanges(
+        final @NotNull Iterable<@NotNull T> tilePositions, @Nullable Block<?> block
+    ) {
+        class ctx { static final ObjectOpenHashSet<TilePosc> CACHE = new ObjectOpenHashSet<>(); }
+        if (this.noNeighborUpdate || this.isClientSide) return;
+        ctx.CACHE.clear();
+
+        for (var pos : tilePositions) {
+            NeighborUpdates.diamondD1(ctx.CACHE, this, pos, block);
+        }
+
+        final var size = ctx.CACHE.size();
+        ctx.CACHE.clear();
+        if (size >= 1024) ctx.CACHE.trim(512);
+    }
+
+    @Deprecated
+    public final void notifyBlocksOfNeighborChange(final int x, final int y, final int z, final int id) {
+        this.notifyBlocksOfNeighborChange(new TilePos(x, y, z), Objects.requireNonNull(Blocks.getBlock(id)));
     }
 
     public boolean canBlockSeeSky(final @NotNull TilePosc tilePos) {
@@ -1824,7 +1951,7 @@ public abstract class World implements MutableWorldSource {
     }
 
     public void onBlockHit(final @NotNull Player player, final @NotNull TilePosc tilePos, final @NotNull Side side) {
-        final @NotNull TilePos offsetPos = tilePos.add(side.getDirection(), new TilePos());
+        final @NotNull TilePos offsetPos = tilePos.add(side.direction(), new TilePos());
         final @Nullable Block<?> block = this.getBlockType(offsetPos);
 
         if (block == Blocks.FIRE || block == Blocks.FIRE_COLD) {
@@ -1893,16 +2020,6 @@ public abstract class World implements MutableWorldSource {
         return block != null && block.isSolidRender();
     }
 
-    public boolean canPlaceOnSurfaceOfBlock(final @NotNull TilePos tilePos) {
-        final @Nullable Block<?> block = this.getBlockType(tilePos);
-        return block != null && block.canPlaceOnSurfaceOnCondition(this, tilePos.x, tilePos.y, tilePos.z);
-    }
-
-    @Deprecated
-    public final boolean canPlaceOnSurfaceOfBlock(final int x, final int y, final int z) {
-        return this.canPlaceOnSurfaceOfBlock(new TilePos(x, y, z));
-    }
-
     public @NotNull ISupport getSupport(final @NotNull TilePos tilePos, final @NotNull Side side) {
         return this.getBlockType(tilePos).getSupport(this, tilePos, side);
     }
@@ -2215,38 +2332,37 @@ public abstract class World implements MutableWorldSource {
     }
 
     public <T extends Entity> @NotNull List<@NotNull T> getEntitiesWithinAABB(@NotNull final Class<T> ofClass, @NotNull final AABBdc aabb) {
+        this.entityBuffer.clear();
         final int minX = MathHelper.floor((aabb.minX() - 2D) / Chunk.CHUNK_SIZE_X);
         final int maxX = MathHelper.floor((aabb.maxX() + 2D) / Chunk.CHUNK_SIZE_X);
         final int minZ = MathHelper.floor((aabb.minZ() - 2D) / Chunk.CHUNK_SIZE_Z);
         final int maxZ = MathHelper.floor((aabb.maxZ() + 2D) / Chunk.CHUNK_SIZE_Z);
-        final List<@NotNull T> entities = new ArrayList<>();
         for (int x = minX; x <= maxX; x++) {
             for (int z = minZ; z <= maxZ; z++) {
                 if (this.isChunkLoaded(x, z)) {
-                    this.getChunkFromChunkCoords(x, z).getEntitiesWithin(ofClass, aabb, entities);
+                    this.getChunkFromChunkCoords(x, z).getEntitiesWithin(ofClass, aabb, (List<T>)this.entityBuffer);
                 }
             }
-
         }
 
-        return entities;
+        return (List<T>)this.entityBuffer;
     }
 
     public <T extends Entity> @NotNull List<@NotNull T> getEntitiesWithinRadius(@NotNull final Class<T> ofClass, final double x, final double y, final double z, final double radius) {
+        this.entityBuffer.clear();
         final int minX = MathHelper.floor(x - radius);
         final int minZ = MathHelper.floor(z - radius);
         final int maxX = MathHelper.ceil(x + radius);
         final int maxZ = MathHelper.ceil(z + radius);
-        final List<@NotNull T> entities = new ArrayList<>();
         for (int bx = minX; bx <= maxX; bx++) {
             for (int bz = minZ; bz <= maxZ; bz++) {
                 if (this.isChunkLoaded(bx, bz)) {
-                    this.getChunkFromChunkCoords(bx, bz).getEntitiesWithinRadius(ofClass, x, y, z, radius, entities);
+                    this.getChunkFromChunkCoords(bx, bz).getEntitiesWithinRadius(ofClass, x, y, z, radius, (List<T>)this.entityBuffer);
                 }
             }
         }
 
-        return entities;
+        return (List<T>)this.entityBuffer;
     }
 
     public @NotNull List<@NotNull Entity> getLoadedEntityList() {
@@ -2377,7 +2493,7 @@ public abstract class World implements MutableWorldSource {
     public boolean hasDirectSignal(final @NotNull TilePosc tilePos) {
         final TilePos queryPos = new TilePos();
         for (final @NotNull Side side : Side.sides) {
-            if (this.hasDirectSignal(tilePos.add(side.getDirection(), queryPos), side)) {
+            if (this.hasDirectSignal(tilePos.add(side.direction(), queryPos), side)) {
                 return true;
             }
         }
@@ -2411,10 +2527,10 @@ public abstract class World implements MutableWorldSource {
     // Special version of hasDirectSignal that excludes the front side of the redstone lantern.
     private boolean pumpkinHasDirectSignal(final @NotNull TilePosc tilePos) {
         for (final @NotNull Side side : Side.sides) {
-            if (Side.getSideById(this.getBlockData(tilePos)) == side) {
+            if (Side.fromId(this.getBlockData(tilePos)) == side) {
                 continue;
             }
-            if (this.hasDirectSignal(tilePos.add(side.getDirection(), new TilePos()), side)) {
+            if (this.hasDirectSignal(tilePos.add(side.direction(), new TilePos()), side)) {
                 return true;
             }
         }
@@ -2424,7 +2540,7 @@ public abstract class World implements MutableWorldSource {
 
     public boolean hasNeighborSignal(final @NotNull TilePosc tilePos) {
         for (final @NotNull Side side : Side.sides) {
-            if (this.hasSignal(tilePos.add(side.getDirection(), new TilePos()), side)) {
+            if (this.hasSignal(tilePos.add(side.direction(), new TilePos()), side)) {
                 return true;
             }
         }
@@ -2703,10 +2819,8 @@ public abstract class World implements MutableWorldSource {
     }
 
     public void triggerEvent(final @NotNull TilePosc tilePos, final int index, final int data) {
-        final @Nullable Block<?> block = this.getBlockType(tilePos);
-        if (block != null) {
-            block.triggerEvent(this, tilePos.x(), tilePos.y(), tilePos.z(), index, data);
-        }
+        final @NotNull Block<?> block = this.getBlockType(tilePos);
+        block.triggerEvent(this, tilePos, index, data);
     }
 
     @Deprecated
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureGlowstone.java b/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureGlowstone.java
index 3005f2033..c9e4b03e7 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureGlowstone.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureGlowstone.java
@@ -30,8 +30,7 @@ public class WorldFeatureGlowstone implements WorldFeatureInterface
                 continue;
             }
             int adjacentGlowstone = 0;
-            for(int d = 0; d < Direction.directions.length; d++) {
-                Direction dir = Direction.getDirectionById(d);
+            for(final var dir : Direction.all) {
                 if(world.getBlockType(queryPos.set(rx, ry, rz).add(dir)) == Blocks.GLOWSTONE) {
                     adjacentGlowstone++;
                 }
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureMoss.java b/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureMoss.java
index 5169d0125..41a5856f9 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureMoss.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureMoss.java
@@ -104,7 +104,7 @@ public class WorldFeatureMoss extends WorldFeature
     public boolean airExposed(@NotNull World world, int x, int y, int z) {
         for (int i = 0; i < Side.sides.length; i++) {
             Side s = Side.sides[i];
-            if (world.isAirBlock(x + s.getOffsetX(), y + s.getOffsetY(), z + s.getOffsetZ())) return true;
+            if (world.isAirBlock(x + s.offsetX(), y + s.offsetY(), z + s.offsetZ())) return true;
         }
         return false;
     }
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureTerrace.java b/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureTerrace.java
index 7023836ab..20d342f65 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureTerrace.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureTerrace.java
@@ -83,7 +83,7 @@ public class WorldFeatureTerrace extends WorldFeature
             return false;
         }
 
-        for (Direction dir : Direction.directions) {
+        for (final var dir : Direction.all) {
             cursor.add(dir, query);
             if(dir == Direction.UP){
                 if (!world.isAirBlock(query)) {
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTreePalm.java b/game/core/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTreePalm.java
index 55b4711d8..a00989b78 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTreePalm.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTreePalm.java
@@ -101,7 +101,7 @@ public class WorldFeatureTreePalm extends WorldFeature {
 		}else {
 			bend = random.nextFloat() * 3.0f + 2.0f;
 		}
-		Direction direction = Direction.horizontalDirections[random.nextInt(4)];
+		Direction direction = Direction.horizontal[random.nextInt(4)];
 		
 		return generateTrunkIfPossible(height, angle, bend, direction);
 	}
@@ -115,9 +115,9 @@ public class WorldFeatureTreePalm extends WorldFeature {
 			float yFactor = i / (float) height;
 			int offset = MathHelper.floor(Math.pow(yFactor, angle + 1.0f) * bend);
 			
-			int offsetX = direction.getOffsetX() * offset;
+			int offsetX = direction.offsetX() * offset;
 			int offsetY = i;
-			int offsetZ = direction.getOffsetZ() * offset;
+			int offsetZ = direction.offsetZ() * offset;
 			
 			intList.add(encode(offsetX, offsetY, offsetZ));
 		}
diff --git a/game/core/src/main/java/net/minecraft/core/world/pos/ChunkPos.java b/game/core/src/main/java/net/minecraft/core/world/pos/ChunkPos.java
index 102c2c9f1..b8d865082 100644
--- a/game/core/src/main/java/net/minecraft/core/world/pos/ChunkPos.java
+++ b/game/core/src/main/java/net/minecraft/core/world/pos/ChunkPos.java
@@ -75,7 +75,7 @@ public final class ChunkPos implements Externalizable, Cloneable, ChunkPosc {
 
     @Override
     public @NotNull ChunkPos add(@NotNull Direction dir, @NotNull ChunkPos dest) {
-        return add(dir.getOffsetX(), dir.getOffsetZ(), dest);
+        return add(dir.offsetX(), dir.offsetZ(), dest);
     }
 
     public @NotNull ChunkPos add(int x, int z) {
@@ -102,7 +102,7 @@ public final class ChunkPos implements Externalizable, Cloneable, ChunkPosc {
 
     @Override
     public @NotNull ChunkPos sub(@NotNull Direction dir, @NotNull ChunkPos dest) {
-        return sub(dir.getOffsetX(), dir.getOffsetZ(), dest);
+        return sub(dir.offsetX(), dir.offsetZ(), dest);
     }
 
     public @NotNull ChunkPos sub(int x, int z) {
diff --git a/game/core/src/main/java/net/minecraft/core/world/pos/ChunkSectionTilePos.java b/game/core/src/main/java/net/minecraft/core/world/pos/ChunkSectionTilePos.java
index 9fd7f0933..a1b5f637b 100644
--- a/game/core/src/main/java/net/minecraft/core/world/pos/ChunkSectionTilePos.java
+++ b/game/core/src/main/java/net/minecraft/core/world/pos/ChunkSectionTilePos.java
@@ -94,7 +94,7 @@ public class ChunkSectionTilePos implements Externalizable, Cloneable, ChunkSect
 
     @Override
     public @NotNull ChunkSectionTilePos add(@NotNull Direction dir, @NotNull ChunkSectionTilePos dest) {
-        return add(dir.getOffsetX(), dir.getOffsetY(), dir.getOffsetZ(), dest);
+        return add(dir.offsetX(), dir.offsetY(), dir.offsetZ(), dest);
     }
 
     public @NotNull ChunkSectionTilePos add(int x, int y, int z) {
@@ -106,7 +106,7 @@ public class ChunkSectionTilePos implements Externalizable, Cloneable, ChunkSect
     }
 
     public @NotNull ChunkSectionTilePos add(@NotNull Direction dir) {
-        return add(dir.getOffsetX(), dir.getOffsetY(), dir.getOffsetZ(), this);
+        return add(dir.offsetX(), dir.offsetY(), dir.offsetZ(), this);
     }
 
     @Override
@@ -121,7 +121,7 @@ public class ChunkSectionTilePos implements Externalizable, Cloneable, ChunkSect
 
     @Override
     public @NotNull ChunkSectionTilePos sub(@NotNull Direction dir, @NotNull ChunkSectionTilePos dest) {
-        return sub(dir.getOffsetX(), dir.getOffsetY(), dir.getOffsetZ(), dest);
+        return sub(dir.offsetX(), dir.offsetY(), dir.offsetZ(), dest);
     }
 
     public @NotNull ChunkSectionTilePos sub(int x, int y, int z) {
@@ -133,7 +133,7 @@ public class ChunkSectionTilePos implements Externalizable, Cloneable, ChunkSect
     }
 
     public @NotNull ChunkSectionTilePos sub(@NotNull Direction dir) {
-        return sub(dir.getOffsetX(), dir.getOffsetY(), dir.getOffsetZ(), this);
+        return sub(dir.offsetX(), dir.offsetY(), dir.offsetZ(), this);
     }
 
     @Override
diff --git a/game/core/src/main/java/net/minecraft/core/world/pos/ChunkTilePos.java b/game/core/src/main/java/net/minecraft/core/world/pos/ChunkTilePos.java
index 97182c78c..dfe28ea69 100644
--- a/game/core/src/main/java/net/minecraft/core/world/pos/ChunkTilePos.java
+++ b/game/core/src/main/java/net/minecraft/core/world/pos/ChunkTilePos.java
@@ -94,7 +94,7 @@ public class ChunkTilePos implements Externalizable, Cloneable, ChunkTilePosc {
 
     @Override
     public @NotNull ChunkTilePos add(@NotNull Direction dir, @NotNull ChunkTilePos dest) {
-        return add(dir.getOffsetX(), dir.getOffsetY(), dir.getOffsetZ(), dest);
+        return add(dir.offsetX(), dir.offsetY(), dir.offsetZ(), dest);
     }
 
     public @NotNull ChunkTilePos add(int x, int y, int z) {
@@ -106,7 +106,7 @@ public class ChunkTilePos implements Externalizable, Cloneable, ChunkTilePosc {
     }
 
     public @NotNull ChunkTilePos add(@NotNull Direction dir) {
-        return add(dir.getOffsetX(), dir.getOffsetY(), dir.getOffsetZ(), this);
+        return add(dir.offsetX(), dir.offsetY(), dir.offsetZ(), this);
     }
 
     @Override
@@ -121,7 +121,7 @@ public class ChunkTilePos implements Externalizable, Cloneable, ChunkTilePosc {
 
     @Override
     public @NotNull ChunkTilePos sub(@NotNull Direction dir, @NotNull ChunkTilePos dest) {
-        return sub(dir.getOffsetX(), dir.getOffsetY(), dir.getOffsetZ(), dest);
+        return sub(dir.offsetX(), dir.offsetY(), dir.offsetZ(), dest);
     }
 
     public @NotNull ChunkTilePos sub(int x, int y, int z) {
@@ -133,7 +133,7 @@ public class ChunkTilePos implements Externalizable, Cloneable, ChunkTilePosc {
     }
 
     public @NotNull ChunkTilePos sub(@NotNull Direction dir) {
-        return sub(dir.getOffsetX(), dir.getOffsetY(), dir.getOffsetZ(), this);
+        return sub(dir.offsetX(), dir.offsetY(), dir.offsetZ(), this);
     }
 
     @Override
diff --git a/game/core/src/main/java/net/minecraft/core/world/pos/TilePos.java b/game/core/src/main/java/net/minecraft/core/world/pos/TilePos.java
index aedd08e22..58453ec8f 100644
--- a/game/core/src/main/java/net/minecraft/core/world/pos/TilePos.java
+++ b/game/core/src/main/java/net/minecraft/core/world/pos/TilePos.java
@@ -134,11 +134,11 @@ public final class TilePos implements Externalizable, Cloneable, TilePosc {
 
     @Override
     public @NotNull TilePos add(@NotNull Direction dir, @NotNull TilePos dest) {
-        return add(dir.getOffsetX(), dir.getOffsetY(), dir.getOffsetZ(), dest);
+        return dir.offset(dest.set(this));
     }
 
     public @NotNull TilePos add(@NotNull Side side, @NotNull TilePos dest) {
-        return add(side.getOffsetX(), side.getOffsetY(), side.getOffsetZ(), dest);
+        return add(side.offsetX(), side.offsetY(), side.offsetZ(), dest);
     }
 
     public @NotNull TilePos add(int x, int y, int z) {
@@ -169,12 +169,12 @@ public final class TilePos implements Externalizable, Cloneable, TilePosc {
 
     @Override
     public @NotNull TilePos sub(@NotNull Direction dir, @NotNull TilePos dest) {
-        return sub(dir.getOffsetX(), dir.getOffsetY(), dir.getOffsetZ(), dest);
+        return dir.offsetScaled(dest.set(this), -1);
     }
 
     @Override
     public @NotNull TilePos sub(@NotNull Side side, @NotNull TilePos dest) {
-        return sub(side.getOffsetX(), side.getOffsetY(), side.getOffsetZ(), dest);
+        return sub(side.offsetX(), side.offsetY(), side.offsetZ(), dest);
     }
 
     public @NotNull TilePos sub(int x, int y, int z) {
diff --git a/game/core/src/main/java/net/minecraft/core/world/weather/WeatherSnow.java b/game/core/src/main/java/net/minecraft/core/world/weather/WeatherSnow.java
index 2d3e063ba..29b900c7b 100644
--- a/game/core/src/main/java/net/minecraft/core/world/weather/WeatherSnow.java
+++ b/game/core/src/main/java/net/minecraft/core/world/weather/WeatherSnow.java
@@ -112,9 +112,8 @@ public class WeatherSnow
                 }
             } else if (blockIdBelow == Blocks.FLUID_WATER_STILL.id() && world.getBlockMetadata(x, y - 1, z) == 0) {
                 if (rand.nextFloat() < world.getWeatherManager().getWeatherPower() * world.getWeatherManager().getWeatherIntensity()) {
-                    for (int i = 0; i < 4; i++) {
-                        Direction direction = Direction.horizontalDirections[i];
-                        Block<?> block = world.getBlock(x + direction.getOffsetX(), y - 1, z + direction.getOffsetZ());
+                    for (final var dir : Direction.horizontal) {
+                        Block<?> block = world.getBlock(x + dir.offsetX(), y - 1, z + dir.offsetZ());
                         if (block == Blocks.ICE || block != null && block.isSolidRender()) {
                             world.setBlockWithNotify(x, y - 1, z, Blocks.ICE.id());
                             break;
diff --git a/game/core/src/main/resources/assets/minecraft/lang/en_US/item.lang b/game/core/src/main/resources/assets/minecraft/lang/en_US/item.lang
index 1783d0edc..939eabe0b 100644
--- a/game/core/src/main/resources/assets/minecraft/lang/en_US/item.lang
+++ b/game/core/src/main/resources/assets/minecraft/lang/en_US/item.lang
@@ -324,6 +324,8 @@ item.bed.name=Bed
 item.bed.desc=Take a nap overnight.
 item.repeater.name=Redstone Repeater
 item.repeater.desc=Delays a redstone signal.
+item.timer.name=Redstone Timer
+item.timer.desc=Continuously switches between two outputs.
 item.map.name=Map
 item.map.blank.name=Blank Map
 item.map.desc=Chart your land!
diff --git a/game/core/src/main/resources/assets/minecraft/lang/en_US/subtitles.lang b/game/core/src/main/resources/assets/minecraft/lang/en_US/subtitles.lang
index 28d05bfd8..a61904b28 100644
--- a/game/core/src/main/resources/assets/minecraft/lang/en_US/subtitles.lang
+++ b/game/core/src/main/resources/assets/minecraft/lang/en_US/subtitles.lang
@@ -91,6 +91,10 @@ subtitles.ambient.weather.rain=Rainfall
 
 subtitles.tile.piston.out=Piston extended
 subtitles.tile.piston.in=Piston retracted
+subtitles.tile.piston.detached=Piston detached
+subtitles.tile.piston.attached=Piston attached
+subtitles.tile.piston.detached.out=Piston failed to extend
+subtitles.tile.piston.detached.in=Piston failed to retract
 
 subtitles.tile.tnt.fuse=TNT lit
 subtitles.tile.sensor_block.sense=Mob sense
diff --git a/game/core/src/main/resources/assets/minecraft/lang/en_US/tile.lang b/game/core/src/main/resources/assets/minecraft/lang/en_US/tile.lang
index 58413130c..1f2511f1a 100644
--- a/game/core/src/main/resources/assets/minecraft/lang/en_US/tile.lang
+++ b/game/core/src/main/resources/assets/minecraft/lang/en_US/tile.lang
@@ -803,6 +803,8 @@ tile.repeater.idle.name=Redstone Repeater
 tile.repeater.idle.desc=Repeats redstone signals over a distance.
 tile.repeater.active.name=Redstone Repeater
 tile.repeater.active.desc=Repeats redstone signals over a distance.
+tile.timer.name=Redstone Timer
+tile.timer.desc=Continuously switches between two outputs.
 
 tile.piston.base.name=Piston
 tile.piston.base.desc=Pushes blocks but does not pull them.
